var input = document.getElementById("inputAutoRender");
var outputRender = document.getElementById("outputAutoRender");
var outputTest = document.getElementById("outputParseTest");
var outputTemp = document.getElementById("demo-output-temp");
var testData = [];

// These are not used in the default version
var outputParse = document.getElementById("demo-output-parse");
var outputString = document.getElementById("demo-output-ansString");
var outputAns = document.getElementById("demo-output-ans");

var checkInteractive = document.getElementById("interactive");
checkInteractive.checked = true;
var checkClearTextArea = document.getElementById("clearTextArea");
var ansString = "";
var coloredString = "";

var defaultDelims = [{left: "$$", right: "$$", display: true}, {left: "\\[", right: "\\]", display: true}, {left: "$", right: "$", display: false}, {left: "\\(", right: "\\)", display: false}]
var ansDelims = [{left: "$$$", right: "$$$", display: true},  {left: "\\[", right: "\\]", display: true}, {left: "$$", right: "$$", display: false}, {left: "\\(", right: "\\)", display: false}]

function copyAnsString() 
{ 
	autoRender();
	document.getElementById("dummy").value = ansString;
	document.getElementById("dummy").focus();
	document.execCommand('SelectAll');
	document.execCommand("Copy", false, null); 
	window.getSelection().removeAllRanges();
	if(document.getElementById("clearTextArea").checked)
	{
		document.getElementById("inputAutoRender").value = "";
	}
	document.getElementById("button").blur();
}

function myErrorCallback(errorText)
{
	//console.error(errorText);
}

function myPreProcess(math)
{
	return math;
}


function interactiveAutoRender()
{
	if(interactive.checked)
	{
		autoRender();
	}
}

function autoRender()
{
	while (outputString != null && outputString.lastChild) 
	{
		outputString.removeChild(outputString.lastChild);
    	}
	while (outputRender.lastChild) 
	{
		outputRender.removeChild(outputRender.lastChild);
   	 }
	while (outputAns != null && outputAns.lastChild) 
	{	
		outputAns.removeChild(outputAns.lastChild);
   	}
	while (outputParse != null && outputParse.lastChild) 
	{
		outputParse.removeChild(outputParse.lastChild);
    	}
    	while (outputTest.lastChild) 
	{
		outputTest.removeChild(outputTest.lastChild);
    	}

	count = 1;

	ansString = "";
	testData = splitWithDelimiters(input.value, defaultDelims);
	
	for(var i = 0; i < testData.length; i++)
	{
		if(testData[i].type == "text")
		{
			ansString = ansString.concat(testData[i].data.replace("~"," "));
			var msgParse = document.createTextNode(testData[i].data);
   			var spanParse = document.createElement("span");
   			spanParse.setAttribute("style", "color:blue");
			spanParse.appendChild(msgParse);
    			outputTest.appendChild(spanParse);
		}
		if(testData[i].type == "math")
		{
			//ansString = ansString.concat(testData[i]);
			var check = 1;
			errorText = ""
			try
			{
				katex.render(testData[i].data, outputTemp, {displayMode: true});
			}
			catch(err)
			{
				errorText = " --> ".concat(err);
				check = 0;
			}			
			var spanParse = document.createElement("span");
			if(check) 
			{
				spanParse.setAttribute("style", "color:green");
			}
			else 
			{ 
				spanParse.setAttribute("style", "color:red");
			}
			var text = "".concat(count).concat(": ").concat(testData[i].data);
			var msgParse = document.createTextNode(text.concat(errorText));
   			spanParse.appendChild(msgParse);
    			outputParse.appendChild(spanParse);
    			outputParse.appendChild(document.createElement("br"));
    		
    			msgParse = document.createTextNode(testData[i].rawData);
   			spanParse = document.createElement("span");
			if(check) 
			{
				spanParse.setAttribute("style", "color:green");
			}
			else 
			{ 
				spanParse.setAttribute("style", "color:red");
			}
			spanParse.appendChild(msgParse);
    			outputTest.appendChild(spanParse);
			count++;
			
			var paper2scan = document.getElementById("paper2scan").checked;
			// AnsString
			if(testData[i].rawData.startsWith("$$")){ansString = ansString.concat("\\[").concat(testData[i].data).concat("\\]");}
			else if(testData[i].rawData.startsWith("$") && paper2scan ){ansString = ansString.concat("$$").concat(testData[i].data).concat("$$");}
			else if(testData[i].rawData.startsWith("$") && !paper2scan){ansString = ansString.concat("\\(").concat(testData[i].data).concat("\\)");}
			else if(testData[i].rawData.startsWith("\\(") && paper2scan ){ansString = ansString.concat("$$").concat(testData[i].data).concat("$$");}
			else if(testData[i].rawData.startsWith("\\(") && !paper2scan){ansString = ansString.concat("\\(").concat(testData[i].data).concat("\\)");}
			else { ansString = ansString.concat(testData[i].rawData); } 
			
			ansString = ansString.replace(/(\r\n|\n|\r)/gm," "); 
		}		
	}
	outputParse.appendChild(document.createElement("br"));
	
	var msgAr = document.createTextNode(input.value);
   	var spanAr = document.createElement("span");
	spanAr.appendChild(msgAr);
    	outputRender.appendChild(spanAr);
	
	if(outputString != null)
	{
		var ansStringText = document.createTextNode(ansString);
		var spanAnsString = document.createElement("span");
		spanAnsString.appendChild(ansStringText);
		outputString.appendChild(spanAnsString);
	}

	try 
	{
		renderMathInElement(outputRender, { delimiters: defaultDelims,  preProcess: myPreProcess, errorCallback: myErrorCallback });
		
		if(outputAns != null)
		{
			var msgAns = document.createTextNode(ansString);
        		var spanAns = document.createElement("span");
			spanAns.appendChild(msgAns);
			outputAns.appendChild(spanAns);

			renderMathInElement(outputAns, { delimiters: ansDelims, errorCallback: myErrorCallback });
		}
		
	} 
	catch(err) 
	{
		console.log(err);
	}

	while (outputTemp.lastChild) 
	{
		outputTemp.removeChild(outputTemp.lastChild);
	}
}

input.addEventListener("input", interactiveAutoRender);
input.value="If \\(x^2=3\\), then $y=\\sqr{3}$. Consider the matrix\n$$A = \\left(\\begin{array}{cc}\n a & b \\\\ \n c & d \\\\ \n\\end{array} \\right).$$"
document.getElementById("dummy").value="";
autoRender();

// These are not used in the default version
var inputDemo = document.getElementById("demo-input");
var outputRenderDemoDisplay = document.getElementById("demo-output-1");
var outputRenderDemoInline = document.getElementById("demo-output-2");
var outputHtmlDemo = document.getElementById("demo-html");

function doDemo() 
{
	try 
	{
		while (outputHtmlDemo.lastChild) 
		{
			outputHtmlDemo.removeChild(outputHtmlDemo.lastChild);
		}
       		katex.render(inputDemo.value, outputRenderDemoDisplay, {displayMode: true});
		katex.render(inputDemo.value, outputRenderDemoInline, {displayMode: false});

		var html = outputRenderDemoInline.innerHTML;
		var msgHtml = document.createTextNode(html);
		var spanHtml = document.createElement("span");
		spanHtml.appendChild(msgHtml);
        outputHtmlDemo.appendChild(spanHtml);
		
    	} 
	catch (err) 
	{
        	while (outputRenderDemoDisplay.lastChild) 
		{
        	outputRenderDemoDisplay.removeChild(outputRenderDemoDisplay.lastChild);
		}
		while (outputRenderDemoInline.lastChild) 
		{
			outputRenderDemoInline.removeChild(outputRenderDemoInline.lastChild);
		}
		var msg = document.createTextNode(err.message);
        var span = document.createElement("span");
        span.appendChild(msg);
        outputRenderDemoDisplay.appendChild(span);
	}
}

if(inputDemo != null)
{
	inputDemo.value="f(x)= \\int g(x)dx"
	inputDemo.addEventListener("input", doDemo);
	doDemo();
}

//document.getElementById("buttonCopy").onClick =testClick;